package core.export;

import core.structures.ITask;
import core.structures.TodoList;

public class CSVExport extends AbstractExport {

	private String	nl	= System.getProperty("line.separator"); // the system's new line character

	private String	sep	= ";";									// the field seperator

	@Override
	String prepareString(TodoList tdl) {
		StringBuilder sb = new StringBuilder();
		sb.append(tdl.getProjectName() + sep);
		sb.append(tdl.getLastModified() + sep);
		sb.append(tdl.getFileformat() + sep);
		sb.append(tdl.getFileversion() + sep);
		sb.append(tdl.getNextuniqeid() + sep);
		sb.append(tdl.getCustomCommentsType() + nl);
		sb.append(fieldNames());
		for (int i = 0; i < tdl.numTasks(); i++) {
			sb.append(prepareString(tdl.getTask(i)));
		}
		return sb.toString();
	}

	private String fieldNames() {
		StringBuilder sb = new StringBuilder();
		sb.append("id" + sep);
		sb.append("title" + sep);
		sb.append("priority" + sep);
		sb.append("percent_done" + sep);
		sb.append("risk" + sep);
		sb.append("start_date" + sep);
		sb.append("done_date" + sep);
		sb.append("last_modification" + sep);
		sb.append("due_date" + sep);
		sb.append("status" + sep);
		sb.append("allocated_by" + sep);
		sb.append("person" + sep);
		sb.append("depends" + sep);
		sb.append("creation_date" + sep);
		sb.append("time_spent" + sep);
		sb.append("time_spent_units" + sep);
		sb.append("external_id" + sep);
		sb.append("time_estimated" + sep);
		sb.append("time_estimated_units" + sep);
		sb.append("category" + sep);
		sb.append("cost" + sep);
		sb.append("comments" + sep);
		sb.append(nl);
		return sb.toString();
	}

	// FIXME format not yet final
	private String prepareString(ITask t) {
		StringBuilder sb = new StringBuilder();
		sb.append(t.getId() + sep); // FIXME this has to be a unique id!
		sb.append(t.getTitle() + sep);
		sb.append(t.getPriority() + sep);
		sb.append(t.getPercentdone() + sep);
		sb.append(t.getRisk() + sep);
		sb.append(t.getStartDate() + sep);
		sb.append(t.getDoneDate() + sep);
		sb.append(t.getLastModifiedDate() + sep);
		sb.append(t.getDueDate() + sep);
		sb.append(t.getStatus() + sep);
		sb.append(t.getAllocatedBy() + sep);
		sb.append(t.getPerson() + sep);
		sb.append(t.getDepends() + sep);
		sb.append(t.getCreationDate() + sep);
		sb.append(t.getTimeSpent() + sep);
		sb.append(t.getTimeSpentUnits() + sep);
		sb.append(t.getExternalId() + sep);
		sb.append(t.getTimeEstimated() + sep);
		sb.append(t.getTimeEstimatedUnits() + sep);
		sb.append(t.getCategory() + sep);
		sb.append(t.getCost() + sep);
		sb.append(t.getComments() + sep);
		sb.append(nl);
		for (int i = 0; i < t.numTasks(); i++) {
			sb.append(prepareString(t.getTask(i)));
		}
		//sb.setLength(sb.length() - nl.length());// remove the last line-feed
		return sb.toString();
	}

}
