package core.gui.views.treemap;

import core.structures.ITask;
import core.structures.TodoList;
import treemap.TMComputeSize;
import treemap.TMExceptionBadTMNodeKind;
import treemap.TMNode;

public class PrioritySize implements TMComputeSize {

	public float getSize(TMNode arg0) throws TMExceptionBadTMNodeKind {
		try {
			// ensure to return a value bigger than 0, because that would look ugly
			return ((ITask) arg0).getPriority() + 1;
		} catch (Exception e) {
			if(arg0 instanceof TodoList)
				return 1;
			throw new TMExceptionBadTMNodeKind(this, arg0);
		}
	}

	public boolean isCompatibleWith(TMNode arg0) {
		if (arg0 instanceof ITask || arg0 instanceof TodoList) {
			return true;
		}
		return false;
	}

}
