package core.imports;

import java.io.File;

import org.apache.log4j.Logger;

import core.structures.TodoList;

public abstract class AbstractImport implements IImport {

	static Logger		logger		= Logger.getLogger(AbstractImport.class);

	private TodoList	tdl			= null;

	private File		inputFile	= null;

	public boolean doImport() throws IllegalStateException {
		if (this.inputFile == null) {
			throw new IllegalStateException("Must set input file first!");
		}
		this.tdl = this.parseInput(this.inputFile);
		return true;
	}

	public File getInputFile() {
		return this.inputFile;
	}

	public TodoList getTodoList() throws IllegalStateException {
		if (this.tdl == null) {
			throw new IllegalStateException("Must call doImport() first.");
		}
		return this.tdl;
	}

	public boolean setInputFile(File file) {
		if (file.canRead()) {
			this.inputFile = file;
			return true;
		} else {
			return false;
		}
	}

	/**
	 * This is the template method that will be implemented by the concrete subclasses.
	 * @return
	 */
	abstract TodoList parseInput(File file);

}
