package core.utils.comparators;

import java.util.Comparator;

import core.structures.ITask;

public class PriorityComparator implements Comparator {

	public int compare(Object o1, Object o2) {
		if (o1 instanceof ITask && o2 instanceof ITask) {
			ITask t1 = (ITask) o1;
			ITask t2 = (ITask) o2;
			if (t1.getPriority() < t2.getPriority())
				return 1;
			if (t1.getPriority() > t2.getPriority())
				return -1;
			return 0;
		} else {
			return 0;
		}
	}

}
